<template>
  <Form
    class="mt-1"
    @submit="validationForm"
    :validation-schema="schema"
    v-slot="{ meta }"
  >
    <b-row>
      <b-col cols="12" class="img-col col-sm-auto col-md-auto col-12" md="2">
        <div class="d-flex justify-content-center">
          <div class="image-placeholder">
            <template v-if="previewProfiePhoto">
              <img :src="previewProfiePhoto" alt="" />
              <div
                v-if="pageType != 'view'"
                class="btn btn-icon rounded-circle img-edit-btn"
                @click="removeImage('profile')"
              >
                <IconTrashImage />
              </div>
            </template>
            <div class="no_image" v-if="!previewProfiePhoto">
              <div
                v-if="pageType != 'view'"
                class="btn btn-icon rounded-circle img-add-btn"
                @click="
                  $refs.profilePhoto.value = null;
                  $refs.profilePhoto.click();
                "
              >
                <IconPlusActive></IconPlusActive>
              </div>
              <div
                v-if="pageType == 'view'"
                class="btn btn-icon rounded-circle img-add-btn-disabled disabled"
              >
                <IconPlusActive></IconPlusActive>
              </div>
            </div>
            <input
              ref="profilePhoto"
              type="file"
              class="d-none"
              accept="image/png, image/gif, image/jpeg"
              @input="uploadImage('profile')"
            />
          </div>
        </div>
        <p class="image_title black-color mb-0">Add Profile Picture</p>
        <p class="image-size-text">Recommended Size</p>
        <p class="image-size-text">500 x 500 px</p>
        <div class="d-flex justify-content-center mt-2">
          <div class="image-placeholder">
            <template v-if="previewSignature">
              <img :src="previewSignature" alt="" />
              <div
                v-if="pageType != 'view'"
                class="btn btn-icon rounded-circle img-edit-btn"
                @click="removeImage('signature')"
              >
                <IconTrashImage />
              </div>
            </template>
            <div class="no_image" v-if="!previewSignature">
              <div
                v-if="pageType != 'view'"
                class="btn btn-icon rounded-circle img-add-btn"
                @click="
                  $refs.signature.value = null;
                  $refs.signature.click();
                "
              >
                <IconPlusActive></IconPlusActive>
              </div>
              <div
                v-if="pageType == 'view'"
                class="btn btn-icon rounded-circle img-add-btn-disabled disabled"
              >
                <IconPlusActive></IconPlusActive>
              </div>
            </div>
            <input
              ref="signature"
              type="file"
              class="d-none"
              accept="image/png, image/gif, image/jpeg"
              @input="uploadImage('signature')"
            />
          </div>
        </div>
        <p class="image_title black-color mb-0">Add Signature</p>
        <p class="image-size-text">Recommended Size</p>
        <p class="image-size-text">500 x 500 px</p>
      </b-col>
      <b-col cols="12" class="img-col col-sm-auto col-md-auto col-12" md="10">
        <div class="card-with-shadow">
          <b-card class="mb-0">
            <b-tabs>
              <!-- Tab: Account -->
              <b-tab active>
                <template #title>
                  <IconUsers class="profile-tab-icon" />
                  <span class="d-none d-sm-inline">Account</span>
                </template>
                <hr />
                <b-row class="form-card">
                  <b-col cols="12" md="6" class="">
                    <b-form-group label="User ID" label-for="user_id">
                      <b-form-input
                        :disabled="pageType == 'view'"
                        id="user_id"
                        readonly
                        v-model="UserModel.user_id"
                        placeholder="Auto Generated"
                      />
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group>
                      <TextInput
                        ref="firstInput"
                        name="username"
                        label="User Name"
                        type="text"
                        placeholder="Enter User Name"
                        :value="UserModel.username"
                        :disabled="
                          pageType == 'view' ||
                          (pageType == 'edit' && UserModel.type == 1)
                        "
                        :maxlength="50"
                        :autofocus="true"
                        @change="(e) => (UserModel.username = e)"
                      >
                      </TextInput>
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group>
                      <TextInput
                        name="email"
                        label="Email ID"
                        type="email"
                        placeholder="Enter Email ID"
                        :value="UserModel.email"
                        :disabled="
                          pageType == 'view' ||
                          (pageType == 'edit' && UserModel.type == 1)
                        "
                        :maxlength="50"
                        :autofocus="true"
                        @change="(e) => (UserModel.email = e)"
                      ></TextInput>
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group>
                      <ContactInput
                        label="Contact Number"
                        name="phone_number"
                        nameCode="country_code"
                        :options="phoneCodes"
                        :value="UserModel.phone_number"
                        :valueCode="UserModel.country_code"
                        :disabled="
                          pageType == 'view' ||
                          (pageType == 'edit' && UserModel.type == 1)
                        "
                        placeholder="Enter Contact Number"
                        @validationUpdate="(e) => (countryCodeValidation = e)"
                        @change="(e) => (UserModel.phone_number = e)"
                      ></ContactInput>
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="" v-if="UserModel.type == 2">
                    <b-form-group>
                      <b-row>
                        <b-col cols="12" md="12">
                          <SelectInput
                            :disabled="pageType == 'view'"
                            :value="UserModel.designation"
                            :options="designationOptions"
                            :clearable="false"
                            input-id="designation"
                            name="designation"
                            label="Designation"
                            placeholder="Select Designation"
                            id="designation"
                            class="eb-select"
                            @change="(e) => (UserModel.designation = e)"
                          >
                          </SelectInput>
                        </b-col>
                        <!-- && ability.can('read', 'designation_setting_view') -->
                        <b-col
                          cols="12"
                          md="2"
                          v-if="
                            (pageType == 'edit' || pageType == 'create') &&
                            ability.can('read', 'designation_setting_view')
                          "
                        >
                          <b-button
                            variant="outline-primary"
                            class="btn-icon rounded-circle designation-btn"
                            @click="showModal = !showModal"
                          >
                            <FeatherIcon icon="SettingsIcon" />
                          </b-button>
                          <template v-if="showModal">
                            <DesignationModel
                              @submit="designationSubmit"
                              @designation="designationValue"
                              @isModalOpen="openModal"
                            ></DesignationModel>
                          </template>
                        </b-col>
                      </b-row>
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="" v-if="UserModel.type == 2">
                    <b-form-group class="mb-1">
                      <SelectInput
                        :disabled="pageType == 'view'"
                        :value="UserModel.role"
                        :options="roleOptions"
                        :clearable="false"
                        name="role"
                        label="Role"
                        placeholder="Select Role"
                        class="eb-select"
                        @change="(e) => (UserModel.role = e)"
                      ></SelectInput>
                    </b-form-group>
                  </b-col>

                  <b-col cols="12" md="12" class="mb-2 px-0">
                    <div class="accordion collapse-icon collapse-default" role="tablist">
                      <b-card no-body class="overflow-visible fill-card p-0 pt-1">
                        <b-card-header
                          block
                          v-b-toggle="'accordion-1'"
                          header-tag="header"
                          class="pt-0  mr-3"
                          role="tab"
                          data-toggle="collapse"
                        >
                          <b-card-title
                            >Fill Additional
                            <span class="text-red">Information</span></b-card-title
                          >
                        </b-card-header>
                        <b-collapse
                          id="accordion-1"
                          accordion="my-accordion"
                          role="tabpanel"
                        >
                          <div class="w-100 d-block m-0 p-0">
                            <div class=" mb-2">
                              <hr />
                            </div>
                            <!-- Additional Information -->
                            <b-row class="form-card inquiry-form mt-1 custom-form px-1">
                              <b-col cols="12" md="6" class=" custom-date-picker">
                                <b-form-group label="Date of Birth" label-for="dob">
                                  <VDatePicker
                                    :disabled="pageType == 'view'"
                                    @dayclick="dobSelected"
                                    class="cursor-context-menu disabled p-0"
                                    :model-value="tempDate"
                                    title-position="left"
                                    :model-config="{
                                      type: 'string',
                                      mask: 'DD/MM/YYYY',
                                    }"
                                    trim-weeks
                                    :first-day-of-week="2"
                                    :masks="{
                                      weekdays: 'WWW',
                                      L: 'DD/MM/YYYY',
                                    }"
                                  >
                                    <template v-slot="{ inputValue, togglePopover }">
                                      <div class="flex items-center">
                                        <input
                                          :disabled="pageType == 'view'"
                                          :value="UserModel.dob"
                                          class="custom-datepicker-input w-100 outline-none"
                                          :placeholder="'DD/MM/YYYY'"
                                          @click="togglePopover()"
                                        />
                                      </div>
                                    </template>
                                  </VDatePicker>
                                </b-form-group>
                              </b-col>
                            </b-row>
                            <b-row class="form-card inquiry-form mt-1 custom-form px-1">
                              <b-col cols="12" md="6" class="">
                                <b-form-group
                                  label="Address Line 1"
                                  label-for="address_one"
                                >
                                  <b-form-input
                                    :disabled="pageType == 'view'"
                                    id="address_one"
                                    :state="false > 0 ? false : null"
                                    v-model="UserModel.address_one"
                                    placeholder="Enter Address Line 1"
                                    v-capitalize
                                    maxlength="100"
                                  />
                                  <small class="text-danger">{{}}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group
                                  label="Address Line 2"
                                  label-for="address_two"
                                >
                                  <b-form-input
                                    :disabled="pageType == 'view'"
                                    id="address_two"
                                    :state="false > 0 ? false : null"
                                    v-model="UserModel.address_two"
                                    placeholder="Enter Address Line 2"
                                    v-capitalize
                                    maxlength="100"
                                  />
                                  <small class="text-danger">{{}}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group label="Postal Code" label-for="pin">
                                  <b-form-input
                                    :disabled="pageType == 'view'"
                                    id="pin"
                                    :state="false > 0 ? false : null"
                                    v-model="UserModel.pin"
                                    placeholder="Enter Postal Code"
                                    maxlength="10"
                                  />
                                  <small class="text-danger">{{}}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group label="Area" label-for="area">
                                  <b-form-input
                                    :disabled="pageType == 'view'"
                                    id="area"
                                    :state="false > 0 ? false : null"
                                    v-model="UserModel.area"
                                    placeholder="Enter Area"
                                    v-capitalize
                                    maxlength="50"
                                  />
                                  <small class="text-danger">{{}}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group label="City" label-for="city">
                                  <b-form-input
                                    :disabled="pageType == 'view'"
                                    id="city"
                                    :state="false > 0 ? false : null"
                                    v-model="UserModel.city"
                                    placeholder="Enter City"
                                    v-capitalize
                                    maxlength="50"
                                  />
                                  <small class="text-danger">{{}}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group label="State / Province" label-for="state">
                                  <b-form-input
                                    :disabled="pageType == 'view'"
                                    id="state"
                                    v-model="UserModel.state"
                                    placeholder="Enter State / Province"
                                    v-capitalize
                                    maxlength="10"
                                  />
                                </b-form-group>
                              </b-col>
                            </b-row>
                          </div>
                        </b-collapse>
                      </b-card>
                    </div>
                  </b-col>
                </b-row>
              </b-tab>
              <b-tab>
                <template #title>
                  <IconRoles class="profile-tab-icon" />
                  <span class="d-none d-sm-inline">Rights</span>
                </template>
                <hr />
                <b-row class="form-card">
                  <b-col cols="12" md="6" class="" v-if="UserModel.type == 2">
                    <b-form-group class="user-role">
                      <label class="d-block" for="role">Role</label>
                      <v-select
                        class="eb-select"
                        :disabled="true"
                        v-model="UserModel.role"
                        :options="roleOptions"
                        :reduce="(val) => val.value"
                        :clearable="false"
                        input-id="role"
                        vid="role"
                      />
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="12" v-if="UserModel.type == 2">
                    <table class="table table-striped permission-table table-cus">
                      <thead>
                        <th class="bg-white">
                          <h4 class="module-head-text">Module</h4>
                        </th>
                        <th colspan="7" class="text-left bg-white">
                          <h4 class="module-head-text">Permissions</h4>
                        </th>
                      </thead>
                      <tbody>
                        <template v-for="permissionOption in permissionOptions">
                          <tr>
                            <td>
                              <p class="module-title mb-0">
                                {{ permissionOption.module }}
                              </p>
                            </td>
                            <template v-for="permission in permissionOption.permissions">
                              <td>
                                <b-form-checkbox
                                  :disabled="
                                    pageType == 'view' || permission.is_active == false
                                  "
                                  :checked="
                                    permission.is_active == true
                                      ? isPermission(permission.value)
                                      : false
                                  "
                                  name="permissions[]"
                                  :id="permission.value"
                                  inline
                                  @change="
                                    permissionChange(permission, $event, permissionOption)
                                  "
                                >
                                  {{ permission.text }}
                                </b-form-checkbox>
                              </td>
                            </template>
                            <td>
                              <template
                                v-if="permissionOption.more_permissions.length != 0"
                              >
                                <b-dropdown
                                  text=""
                                  variant="link"
                                  right
                                  no-caret
                                  class="more-tab"
                                >
                                  <template #button-content>
                                    <span class="ml-50 text-body float-left font-700"
                                      >More</span
                                    >
                                    <b-img
                                      :src="downArrowIcon"
                                      class="text-body float-right"
                                    />
                                  </template>
                                  <b-dropdown-form>
                                    <template
                                      v-for="more_permission in permissionOption.more_permissions"
                                    >
                                      <b-form-checkbox
                                        :disabled="
                                          pageType == 'view' ||
                                          more_permission.is_active == false
                                        "
                                        :checked="
                                          more_permission.is_active == true
                                            ? isPermission(more_permission.value)
                                            : false
                                        "
                                        name="more_permission[]"
                                        :id="more_permission.value"
                                        inline
                                        @change="
                                          permissionChange(
                                            more_permission,
                                            $event,
                                            permissionOption
                                          )
                                        "
                                      >
                                        {{ more_permission.text }}
                                      </b-form-checkbox>
                                    </template>
                                  </b-dropdown-form>
                                </b-dropdown>
                              </template>
                            </td>
                          </tr>
                        </template>
                      </tbody>
                    </table>
                  </b-col>
                  <b-col cols="12" md="12" v-if="UserModel.type == 1">
                    <center>
                      <h3 class="mt-5 mb-5">
                        This is Company Admin account. It has complete rights.
                      </h3>
                    </center>
                  </b-col>
                </b-row>
              </b-tab>
              <b-tab>
                <template #title>
                  <IconSettings class="profile-tab-icon" />
                  <span class="d-none d-sm-inline">Settings</span>
                </template>
                <hr />
                <b-row>
                  <!-- Field: Setting Table -->
                  <b-col cols="10" md="10">
                    <table class="table table-borderless setting-table">
                      <tbody>
                        <tr>
                          <th>Settings Details</th>
                          <th class="text-center">Web</th>
                          <th class="text-center">Mobile</th>
                        </tr>
                        <tr>
                          <td>
                            <p class="mb-0">Login Based On OTP?</p>
                            <p class="note-text mb-0">
                              Note: Default Login is password based.
                            </p>
                          </td>
                          <td>
                            <b-form-group class="text-center">
                              <b-form-checkbox
                                :disabled="pageType == 'view'"
                                :checked="UserModel.otp_based_login_web"
                                name="check-button"
                                
                                inline
                                @change="
                                  checkBoxValueChange($event, 'otp_based_login_web')
                                "
                              >
                              </b-form-checkbox>
                            </b-form-group>
                          </td>
                          <td>
                            <b-form-group class="text-center">
                              <b-form-checkbox
                                :disabled="pageType == 'view'"
                                :checked="UserModel.otp_based_login_mobile"
                                name="check-button"
                                
                                inline
                                @change="
                                  checkBoxValueChange($event, 'otp_based_login_mobile')
                                "
                              >
                              </b-form-checkbox>
                            </b-form-group>
                          </td>
                        </tr>
                        <tr
                          v-if="
                            UserModel.otp_based_login_web ||
                            UserModel.otp_based_login_mobile
                          "
                        >
                          <td>
                            <b-form-group>
                              <div class="demo-inline-spacing">
                                <b-form-checkbox
                                  :disabled="pageType == 'view'"
                                  id="otp_on_mail"
                                  :checked="UserModel.otp_on_mail"
                                  name="otp_on_mail"
                                  class="my-0 custome-checkbox-lable-inline"
                                  @change="checkBoxValueChange($event, 'otp_on_mail')"
                                >
                                  OTP On Mail
                                </b-form-checkbox>
                                <b-form-checkbox
                                  :disabled="pageType == 'view'"
                                  id="otp_on_message"
                                  :checked="UserModel.otp_on_message"
                                  name="otp_on_message"
                                  class="my-0 custome-checkbox-lable-inline"
                                  @change="checkBoxValueChange($event, 'otp_on_message')"
                                >
                                  OTP On Message
                                </b-form-checkbox>
                              </div>
                            </b-form-group>
                          </td>
                          <td></td>
                          <td></td>
                        </tr>
                        <tr>
                          <td class="setting-td">
                            <p class="mb-0">Login Based On IP Restrication?</p>
                            <p class="note-text mb-0">
                              Note: Select if you want to restrict user login based on IP.
                            </p>
                          </td>
                          <td class="setting-td">
                            <b-form-group class="text-center">
                              <CheckboxInput
                              :class="'custom-control custom-control-inline custom-checkbox'"
                                :isSwitch="false"
                                :disabled="pageType == 'view'"
                                :value="UserModel.ip_based_login_web"
                                name="ip_based_login_web"
                                label=""
                                @change="
                                  checkBoxValueChange($event, 'ip_based_login_web')
                                "
                              ></CheckboxInput>
                            </b-form-group>
                          </td>
                          <td class="setting-td">
                            <b-form-group class="text-center">
                              <CheckboxInput
                              :class="'custom-control custom-control-inline custom-checkbox'"
                                :isSwitch="false"
                                :disabled="pageType == 'view'"
                                :value="UserModel.ip_based_login_mobile"
                                name="ip_based_login_mobile"
                                label=""
                                @change="
                                  checkBoxValueChange($event, 'ip_based_login_mobile')
                                "
                              ></CheckboxInput>
                            </b-form-group>
                          </td>
                        </tr>
                        <tr
                          v-if="
                            UserModel.ip_based_login_web ||
                            UserModel.ip_based_login_mobile
                          "
                        >
                          <td>
                            <label>Permitted IP <span class="text-danger">*</span></label>
                              <SelectTagInput class="ip-box"
                                :disabled="pageType == 'view'"
                                v-model="UserModel.ip_options"
                                name="ip_options"
                                placeholder="Add IPs"
                              ></SelectTagInput>
                          </td>
                          <td></td>
                          <td></td>
                        </tr>
                        <tr>
                          <td class="setting-td">
                            <p class="mb-0">Auto Logout User?</p>
                            <p class="note-text mb-0">
                              Note: If you want user to auto logout daily.
                            </p>
                          </td>
                          <td class="setting-td">
                            <b-form-group class="text-center">
                              <b-form-checkbox
                                :disabled="pageType == 'view'"
                                :checked="UserModel.auto_logout_web"
                                name="check-button"
                                
                                inline
                                @change="checkBoxValueChange($event, 'auto_logout_web')"
                              >
                              </b-form-checkbox>
                            </b-form-group>
                          </td>
                          <td class="setting-td">
                            <b-form-group class="text-center">
                              <b-form-checkbox
                                :disabled="pageType == 'view'"
                                :checked="UserModel.auto_logout_mobile"
                                name="check-button"
                                
                                inline
                                @change="
                                  checkBoxValueChange($event, 'auto_logout_mobile')
                                "
                              >
                              </b-form-checkbox>
                            </b-form-group>
                          </td>
                        </tr>
                        <tr
                          v-if="UserModel.auto_logout_web || UserModel.auto_logout_mobile"
                        >
                          <td>
                            <label>Auto Logout Time</label>
                            <b-form-group class="auto-logout-group">
                              <b-input-group
                                label="Auto Logout At"
                                label-for="auto_logout_at"
                                append="IST"
                                class="auto_logout_at"
                              >
                                <b-form-timepicker
                                :hour12="false"
                                  :disabled="pageType == 'view'"
                                  v-model="UserModel.auto_logout_at"
                                />
                              </b-input-group>
                            </b-form-group>
                          </td>
                          <td></td>
                          <td></td>
                        </tr>

                        <!-- <tr>
                            <td>
                              <p class="mt-1 mb-0">Forgot Password Based On OTP ?</p>
                              <p class="note-text mb-0">
                                Note: Default Forgot Password OTP on email
                              </p>
                            </td>
                            <td>
                              <b-form-group>
                                <b-form-checkbox
                                  :disabled="true"
                                  name="check-button"
                                  :checked="true"
                                  switch
                                  inline
                                >
                                </b-form-checkbox>
                              </b-form-group>
                            </td>
                            <td>
                              <b-form-group>
                                <b-form-checkbox
                                  :disabled="true"
                                  name="check-button"
                                  :checked="true"
                                  switch
                                  inline
                                >
                                </b-form-checkbox>
                              </b-form-group>
                            </td>
                          </tr>
                          <tr>
                            <td>
                              <b-form-group class="ml-4">
                                <div class="demo-inline-spacing">
                                  <b-form-checkbox
                                    :disabled="pageType == 'view'"
                                    id="password_otp_on_mail"
                                    :checked="UserModel.password_otp_on_mail"
                                    name="password_otp_on_mail"
                                    class="my-0"
                                    @change="
                                      passwordOtpChange($event, 'password_otp_on_mail')
                                    "
                                  >
                                    OTP On Mail
                                  </b-form-checkbox>
                                  <b-form-checkbox
                                    :disabled="pageType == 'view'"
                                    id="password_otp_on_message"
                                    :checked="UserModel.password_otp_on_message"
                                    name="password_otp_on_message"
                                    class="my-0"
                                    @change="
                                      passwordOtpChange($event, 'password_otp_on_message')
                                    "
                                  >
                                    OTP On Message
                                  </b-form-checkbox>
                                </div>
                              </b-form-group>
                            </td>
                            <td></td>
                            <td></td>
                          </tr> -->
                      </tbody>
                    </table>
                  </b-col>
                </b-row>
              </b-tab>
              <b-tab>
                <template #title>
                  <IconHistory class="profile-tab-icon" />
                  <span class="d-none d-sm-inline">History</span>
                </template>
                <hr />
                <b-row class="px-1">
                  <!-- Search -->

                  <b-col
                    cols="4"
                    class="search-input-center search-bx d-flex justify-content-start"
                  >
                  </b-col>
                  <b-col
                    cols="4"
                    class="search-input-center search-bx d-flex justify-content-center"
                  >
                    <div class="d-flex search-input-text index-search-form-group">
                      <!--align-items-center justify-content-start-->
                      <b-form-group>
                        <div class="d-flex align-items-center">
                          <!-- <label class="mr-1">Search</label> -->
                          <IconSearchMute class="custom-search-icon" />
                          <b-form-input
                            v-model="searchQuery"
                            placeholder="Search"
                            type="text"
                            class="d-inline-block custom-search-box index-search"
                          />
                        </div>
                      </b-form-group>
                    </div>
                  </b-col>
                  <b-col
                    cols="4"
                    class="search-input-center search-bx d-flex justify-content-end"
                  >
                    <div class="d-flex align-items-center justify-content-end"></div>
                  </b-col>
                </b-row>
                <b-card no-body class="mb-0 table-card table-hover mt-1">
                  <b-table
                    ref="refListTable"
                    class="position-relative has_checkbox"
                    :items="fetchTableData"
                    responsive
                    :fields="tableColumns"
                    primary-key="id"
                    v-model:sort-by="sortBy"
                    show-empty
                    empty-text="No matching records found"
                    v-model:sort-desc="isSortDirDesc"
                  >
                    <template #cell(date)="data">
                      {{ format_date_time(data.item.created_at, "date") }}
                    </template>
                    <template #cell(time)="data">
                      {{ format_date_time(data.item.created_at, "time") }}
                    </template>
                    <template #cell(device)="data">
                      {{ data.item.device }}
                      {{ data.item.device_name != null ? data.item.device_name : "" }}
                    </template>
                  </b-table>
                </b-card>
                <div class="mx-1 mb-2 mt-1">
                  <b-row class="align-items-center">
                    <!-- Per Page -->
                    <b-col
                      cols="12"
                      sm="4"
                      class="d-flex align-items-center justify-content-center justify-content-sm-start"
                    >
                    </b-col>
                    <b-col
                      cols="12"
                      sm="4"
                      class="search-input-center search-bx d-flex justify-content-center"
                    >
                      <b-row class="align-items-center mb-0 mt-0">
                        <div>
                          <span class="text-nowrap mr-1"> Show</span>
                        </div>
                        <div>
                          <pagination-select-dropdown
                            :options="perPageOptions"
                            :selectedValue="perPage"
                            @perPage="changePerPage"
                          />
                          <!-- <v-select
                              :searchable="false"
                              class="rounded-lg"
                              v-model="perPage"
                              :options="perPageOptions"
                              :clearable="false"
                              placeholder="Code"
                              :tabindex="5"
                            /> -->
                        </div>
                        <div>
                          <span class="text-nowrap ml-2" v-if="dataMeta"
                            >Showing {{ dataMeta ? dataMeta.from : "" }} -
                            {{ dataMeta.to }} / {{ dataMeta.of }}</span
                          >
                        </div>
                      </b-row>
                    </b-col>
                    <b-col
                      cols="12"
                      sm="4"
                      class="d-flex align-items-center justify-content-center justify-content-sm-end"
                    >
                      <b-pagination
                        v-model="currentPage"
                        :total-rows="totalData"
                        :per-page="perPage"
                        first-number
                        last-number
                        class="mb-0 mt-1 mt-sm-0"
                        prev-class="prev-item"
                        next-class="next-item"
                      >
                        <template #prev-text>
                          <FeatherIcon icon="ChevronLeftIcon" size="18" />
                        </template>
                        <template #next-text>
                          <FeatherIcon icon="ChevronRightIcon" size="18" />
                        </template>
                      </b-pagination>
                    </b-col>
                  </b-row>
                </div>
              </b-tab>
            </b-tabs>
          </b-card>
        </div>
        <b-row class="mt-2">
          <b-col cols="12" md="6" class="px-4">
            <div class="d-flex form-status">
              <label class="d-block pt-1 mr-1" for="status"
                >Status <span class="text-danger">*</span></label
              >
              <b-form-checkbox
                :disabled="
                  pageType == 'view' || (pageType == 'edit' && UserModel.type == 1)
                "
                :readonly="
                  pageType == 'view' || (pageType == 'edit' && UserModel.type == 1)
                "
                class="status-switch"
                :checked="UserModel.status"
                switch
                name="check-button"
                @change="checkBoxValueChange($event, 'status')"
              />
            </div>
          </b-col>
          <b-col cols="12" md="6" class="px-4 text-right">
            <b-button
              class="btn-reset"
              variant="flat-secondary"
              type="button"
              v-if="
                pageType != 'view' && (UserModel.id != userData.id || userData.type == 1)
              "
              @click.prevent="getModelData"
            >
              Reset
            </b-button>
            <b-button
              class="btn-submit-edit"
              v-if="
                pageType != 'view' && (UserModel.id != userData.id || userData.type == 1)
              "
              variant="primary"
              type="submit"
            >
              <b-spinner small v-if="isSubmit" />
              Save
            </b-button>
            <b-button
              class="btn-submit-edit"
              v-if="pageType == 'view'"
              variant="primary"
              type="submit"
              @click.prevent="changeMode(UserModel.id)"
            >
              <b-spinner small v-if="isSubmit" />
              Edit
            </b-button>
          </b-col>
        </b-row>
      </b-col>
    </b-row>
  </Form>
</template>
<script>
import {
  BCard,
  BRow,
  BCol,
  BAlert,
  BFormInput,
  BButton,
  BTable,
  BMedia,
  BAvatar,
  BLink,
  BBadge,
  BDropdown,
  BDropdownItem,
  BPagination,
  BFormGroup,
  BForm,
  BCardBody,
  BCardHeader,
  BCardFooter,
  BCardTitle,
  BFormCheckbox,
  BFormRadioGroup,
  BFormCheckboxGroup,
  BDropdownForm,
  BTab,
  BTabs,
  BFormTimepicker,
  BFormFile,
  BSpinner,
  BFormSelect,
  BInputGroup,
  BCollapse,
  VBToggle,
  BImg,
} from "bootstrap-vue";
import vSelect from "vue-select";
import store from "@/store";
import Ripple from "vue-ripple-directive";
import { ref, onUnmounted, computed } from "vue";
import userService from "./service";
import UserModel from "./model/user";
import { useRoute } from "vue-router";
import flatPickr from "vue-flatpickr-component";
import DesignationModel from "./designation/AddEditModel.vue";
import moment from "moment";
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import commonModule from "../common/module";
import ability from "@/libs/acl/ability";
import useAppConfig from "@core/app-config/useAppConfig";

import PaginationSelectDropdown from "@/views/common/components/c-select-dropdown/PaginationSelectDropdown.vue";
import countrycode from "@/countrycode.json";
import { useToast } from "vue-toastification";
import * as yup from "yup";
import { Form, useForm, ErrorMessage, Field } from "vee-validate";
import "moment-timezone";
import timeZone from "@/timeZone.json";

const toast = useToast();

export default {
  components: {
    Form,
    BCollapse,
    BImg,
    BCard,
    BRow,
    BCol,
    BAlert,
    BFormInput,
    BButton,
    BTable,
    BMedia,
    BAvatar,
    BLink,
    BBadge,
    BDropdown,
    BDropdownItem,
    BPagination,
    vSelect,
    BFormSelect,
    BFormGroup,
    BForm,
    BCardHeader,
    BCardTitle,
    BFormCheckbox,
    BCardBody,
    BCardFooter,
    flatPickr,
    BFormRadioGroup,
    DesignationModel,
    BFormCheckboxGroup,
    BDropdownForm,
    BTab,
    BTabs,
    BFormTimepicker,
    BFormFile,
    BSpinner,
    BInputGroup,
    VBToggle,
    PaginationSelectDropdown,
  },
  setup() {
    const router = useRoute();
    const userData = JSON.parse(localStorage.getItem("userData"));

    const USER_APP_STORE_MODULE_NAME = "users";

    // Register module
    if (!store.hasModule(USER_APP_STORE_MODULE_NAME))
      store.registerModule(USER_APP_STORE_MODULE_NAME, userService);

    // UnRegister on leave
    onUnmounted(() => {
      // if (store.hasModule(USER_APP_STORE_MODULE_NAME))
      //   store.unregisterModule(USER_APP_STORE_MODULE_NAME);
    });

    var { userProfilePhoto } = useAppConfig();

    if (router.params && router.params.id) {
      const {
        refListTable,
        fetchTableData,
        perPage,
        currentPage,
        totalData,
        dataMeta,
        perPageOptions,
        searchQuery,
        sortBy,
        isSortDirDesc,
        refetchData,
      } = commonModule(
        USER_APP_STORE_MODULE_NAME,
        "users/login_history",
        {
          id: router.params.id,
        },
        "id",
        false
      );

      return {
        // Sidebar
        refListTable,
        fetchTableData,
        perPage,
        currentPage,
        totalData,
        dataMeta,
        perPageOptions,
        searchQuery,
        sortBy,
        isSortDirDesc,
        refetchData,
        userData,
        userProfilePhoto,
      };
    } else {
      return {
        userProfilePhoto,
        userData,
      };
    }
  },
  data() {
    const tableColumns = [
      { key: "login_type", sortable: true },
      { key: "date", sortable: true },
      { key: "time", sortable: true },
      { label: "IP", key: "ip", sortable: true },
      { key: "device", sortable: true },
      { label: "Device ID", key: "device_id", sortable: true },
      { key: "os_version", sortable: true },
      { key: "app_version", sortable: true },
      { key: "access_token", sortable: true },
    ];

    let tempDate = "";
    return {
      tempDate,
      errors: {},
      downArrowIcon: new URL("/src/assets/images/icons/down-arrow.svg", import.meta.url)
        .href,
      ability,
      showModal: false,
      pageType: this.$route.meta.type,
      isEditUser: false,
      tableColumns,
      isSubmit: false,
      UserModel,
      CompanyDetails: [],

      designationOptions: [],
      roleOptions: [],
      permissionOptions: [],
      permissionsSelected: [],
      addAdditionDetails: false,
      customizeRole: false,
      addAddress: false,
      ipOptions: [],
      phoneCodes: [],
      currentSignature: "",
      previewSignature: "",
      currentProfiePhoto: "",
      previewProfiePhoto: "",
      dpconfig: {
        dateFormat: "d/m/Y",
        onOpen: function (selectedDates, dateStr, instance) {
          if (this.input.value == "") {
            instance.setDate("01/01/1990");
          }
        },
      },
      countryCodeValidation: { minLength: 10, maxLength: 10 },
      logoutTimeZone: "UTC",
    };
  },
  directives: {
    Ripple,
    "b-toggle": VBToggle,
  },
  computed: {
    accordion() {
      return this.$parent.accordion ? `accordion-${this.$parent.collapseID}` : null;
    },
    schema() {
      return this.UserModel.type == 2
        ? yup.object().shape({
            username: yup.string().required("Please enter User Name"),
            designation: yup.string().required("Please select Designation"),
            role: yup.string().required("Please select Role"),
            email: yup.string().required("Please enter Email ID").email(),
            ip_based_login_mobile: yup.boolean(),
            ip_based_login_web: yup.boolean(),
            country_code: yup.string(),
            phone_number: yup
              .string("Please enter Contact Number")
              .when(["country_code"], {
                is: (country_code) => {
                  return country_code;
                },
                then: (schema) =>
                  schema
                    .min(
                      this.countryCodeValidation.minLength,
                      "Contact Number must be at least " +
                        this.countryCodeValidation.minLength +
                        " digits"
                    )
                    .max(
                      this.countryCodeValidation.maxLength,
                      "Contact Number must be " +
                        this.countryCodeValidation.maxLength +
                        " digits"
                    ),
                otherwise: (schema) => schema,
              }),
            ip_options: yup
              .array("Please enter Permitted IP")
              .when(["ip_based_login_mobile", "ip_based_login_web"], {
                is: (ip_based_login_mobile, ip_based_login_web) => {
                  return ip_based_login_mobile || ip_based_login_web;
                },
                then: (schema) =>
                  schema.min(1, "Please enter Permitted IP").of(yup.string()),
                otherwise: (schema) => schema,
              }),
          })
        : yup.object().shape({
            username: yup.string().required("Please enter User Name"),
            designation: yup.string(),
            role: yup.string(),
            email: yup.string().required("Please enter Email ID").email(),
            country_code: yup.string(),
            phone_number: yup
              .string("Please enter Contact Number")
              .when(["country_code"], {
                is: (country_code) => {
                  return country_code;
                },
                then: (schema) =>
                  schema
                    .min(
                      this.countryCodeValidation.minLength,
                      "Contact Number must be at least " +
                        this.countryCodeValidation.minLength +
                        " digits"
                    )
                    .max(
                      this.countryCodeValidation.maxLength,
                      "Contact Number must be " +
                        this.countryCodeValidation.maxLength +
                        " digits"
                    ),
                otherwise: (schema) => schema,
              }),
            ip_based_login_mobile: yup.boolean(),
            ip_based_login_web: yup.boolean(),
            ip_options: yup
              .array("Please enter Permitted IP")
              .when(["ip_based_login_mobile", "ip_based_login_web"], {
                is: (ip_based_login_mobile, ip_based_login_web) => {
                  return ip_based_login_mobile || ip_based_login_web;
                },
                then: (schema) =>
                  schema.min(1, "Please enter Permitted IP").of(yup.string()),
                otherwise: (schema) => schema,
              }),
          });
    },
  },
  mounted() {
    var systemTimeZone = Intl.DateTimeFormat().resolvedOptions().timeZone;
    if (timeZone[systemTimeZone] != undefined) {
      this.logoutTimeZone = timeZone[systemTimeZone];
    } else {
      this.logoutTimeZone = systemTimeZone;
    }
    const router = useRoute();
    this.id = router?.params?.id;
    this.getModelData();
  },
  methods: {
    dobSelected(e) {
      let selectedDate =
        ("0" + e.day).slice(-2) + "/" + ("0" + e.month).slice(-2) + "/" + e.year;
      let tempDate =
        ("0" + e.month).slice(-2) + "/" + ("0" + e.day).slice(-2) + "/" + e.year;
      if (selectedDate == this.UserModel.dob) {
        this.UserModel.dob = "";
        this.tempDate = "";
      } else {
        this.UserModel.dob = selectedDate;
        this.tempDate = tempDate;
      }
    },

    changePerPage(value) {
      this.perPage = value;
    },
    isNumber(e) {
      let char = String.fromCharCode(e.keyCode); // Get the character
      if (/^[0-9]+$/.test(char)) return true;
      // Match with regex
      else e.preventDefault(); // If not match, don't add to input text
    },
    changeMode(id) {
      this.$router.push({ name: "all-user-edit", params: { id: id } }).then(() => {
        this.getModelData();
      });
    },
    getModelData() {
      if (this.id) {
        this.isEditUser = true;
        const appLoading = document.getElementById("loading-bg");
        if (appLoading) {
          appLoading.style.display = "block";
        }

        const editAc = store.dispatch("users/edit", { id: this.id });
        if (editAc) {
          editAc
            .then((response) => {
              this.createNew = false;
              this.pageType = this.$route.meta.type;
              const data = response.data.result;
              this.UserModel.id = data.id;
              this.UserModel.type = data.type;
              this.UserModel.user_id = data.user_id;
              this.UserModel.company_id = data.company_id;
              this.UserModel.username = data.name;
              this.UserModel.email = data.email;
              this.UserModel.country_code = data.phone_code;
              this.UserModel.phone_number = data.phone_number;
              this.UserModel.dob = data.dob
                ? moment(data.dob).format("DD/MM/YYYY")
                : "01/01/1990";
              this.tempDate = data.dob;
              this.UserModel.designationData = data.designationData;
              this.UserModel.designation = data.designation;
              this.UserModel.role = data.role;
              this.permissionsSelected = data.permissions;
              this.UserModel.address_one = data.address_one ? data.address_one : "";
              this.UserModel.address_two = data.address_two ? data.address_two : "";
              this.UserModel.area = data.area ? data.area : "";
              this.UserModel.city = data.city ? data.city : "";
              this.UserModel.state = data.state ? data.state : "";
              this.UserModel.pin = data.pin ? data.pin : "";
              this.UserModel.ip_based_login_mobile =
                data.ip_based_login_mobile == 1 ? true : false;
              this.UserModel.ip_based_login_web =
                data.ip_based_login_web == 1 ? true : false;
              this.UserModel.otp_based_login_mobile =
                data.otp_based_login_mobile == 1 ? true : false;
              this.UserModel.otp_based_login_web =
                data.otp_based_login_web == 1 ? true : false;
              this.UserModel.auto_logout_mobile =
                data.auto_logout_mobile == 1 ? true : false;
              this.UserModel.auto_logout_web = data.auto_logout_web == 1 ? true : false;
              this.UserModel.otp_on_mail = data.otp_on_mail == 1 ? true : false;
              this.UserModel.otp_on_message = data.otp_on_message == 1 ? true : false;
              this.UserModel.password_otp_on_mail =
                data.password_otp_on_mail == 1 ? true : false;
              this.UserModel.password_otp_on_message =
                data.password_otp_on_message == 1 ? true : false;
              this.UserModel.status = data.status == 1 ? true : false;
              this.UserModel.ip_options = data.ip_options ? data.ip_options : "";
              this.UserModel.auto_logout_at = this.time_convert(2, data.auto_logout_at);
              if (data.signature) {
                this.previewSignature = data.signature
                  ? import.meta.env.VITE_API_URL + data.signature
                  : "";;
              } else {
                this.previewSignature = "";
              }
              if (data.profile) {
                this.previewProfiePhoto = data.profile
                  ? import.meta.env.VITE_API_URL + data.profile
                  : "";
              } else {
                this.previewProfiePhoto = "";
              }

              store
                .dispatch("users/countryCode")
                .then((response) => {
                  this.phoneCodes = response.data.result;
                })
                .catch(() => {});
              store
                .dispatch("users/userOptionList", { id: data.company_id })
                .then((response) => {
                  const data = response.data.result;
                  this.designationOptions = data.designation;
                  if (this.UserModel.designationData != null) {
                    let currentDesignation = {
                      label: this.UserModel.designationData.name,
                      value: this.UserModel.designationData.id,
                    };
                    let include = false;
                    this.designationOptions.forEach((element) => {
                      if (
                        include == false &&
                        element.value == this.UserModel.designationData.id
                      ) {
                        include = true;
                      }
                    });
                    if (include == false) {
                      this.designationOptions.push(currentDesignation);
                    }
                  }
                  this.roleOptions = data.role;
                  this.permissionOptions = data.permissions;
                })
                .catch((e) => {
                  console.log(e);
                });

              appLoading.style.display = "none";
            })
            .catch((error) => {
              appLoading.style.display = "none";
            });
        }
      }
    },
    changedCompanyValue(value) {
      store
        .dispatch("users/companyDesignationList", { id: value })
        .then((response) => {
          this.designationOptions = response.data.result;
          let currentDesignation = {
            label: this.UserModel.designationData.name,
            value: this.UserModel.designationData.id,
          };
          let include = false;
          this.designationOptions.forEach((element) => {
            if (include == false && element.value == this.UserModel.designationData.id) {
              include = true;
            }
          });
          if (include == false) {
            this.designationOptions.push(currentDesignation);
          }
        })
        .catch(() => {});
    },
    changedPermissions(value) {
      this.customizeRole = false;
      store
        .dispatch("users/permissionByRole", {
          id: value,
          company: this.UserModel.company_id,
        })
        .then((response) => {
          this.permissionsSelected = response.data.result.permissions;
        })
        .catch(() => {});
    },
    validationForm(values, { setErrors }) {
      if (true) {
        this.isSubmit = true;
        const appLoading = document.getElementById("loading-bg");
        if (appLoading) {
          appLoading.style.display = "block";
        }
        let formData = new FormData();
        formData.append("is_profile", this.previewProfiePhoto);
        formData.append("is_signature", this.previewSignature);
        formData.append("profile", this.currentProfiePhoto);
        formData.append("signature", this.currentSignature);
        formData.append("type", UserModel.type);
        formData.append("username", values.username);
        formData.append("email", values.email);
        formData.append("phone_code", values.country_code);
        formData.append("phone_number", values.phone_number);
        formData.append("dob", UserModel.dob);
        formData.append("address_one", UserModel.address_one);
        formData.append("address_two", UserModel.address_two);
        formData.append("area", UserModel.area);
        formData.append("city", UserModel.city);
        formData.append("state", UserModel.state);
        formData.append("pin", UserModel.pin);
        formData.append("ip_options", values.ip_options ? values.ip_options : "");
        formData.append("ip_based_login_web", UserModel.ip_based_login_web);
        formData.append("ip_based_login_mobile", UserModel.ip_based_login_mobile);
        formData.append("otp_based_login_web", UserModel.otp_based_login_web);
        formData.append("otp_based_login_mobile", UserModel.otp_based_login_mobile);
        formData.append("auto_logout_web", UserModel.auto_logout_web);
        formData.append("auto_logout_mobile", UserModel.auto_logout_mobile);
        formData.append("otp_on_mail", UserModel.otp_on_mail);
        formData.append("otp_on_message", UserModel.otp_on_message);
        formData.append("password_otp_on_mail", UserModel.password_otp_on_mail);
        formData.append("password_otp_on_message", UserModel.password_otp_on_message);
        formData.append("auto_logout_at", this.time_convert(1, UserModel.auto_logout_at));
        formData.append("role", values.role ? values.role : "");
        formData.append("designation", values.designation ? values.designation : "");
        formData.append("permissions", this.permissionsSelected);
        formData.append("status", UserModel.status);
        if (UserModel.id) {
          formData.append("id", UserModel.id);
        }
        store
          .dispatch("users/save", formData)
          .then((response) => {
            if (response.data.status == true) {
              this.$router
                .push({
                  name: "all-users-list",
                })
                .then(() => {
                  this.showToast(
                    "success",
                    "CheckCircleIcon",
                    response.data.title,
                    response.data.message
                  );
                  this.isSubmit = false;
                });
            } else {
              if (response.data.errors) {
                setErrors(response.data.errors);
              } else {
                this.showToast(
                  "danger",
                  "AlertCircleIcon",
                  response.data.title,
                  response.data.message
                );
              }

              this.isSubmit = false;
            }
            appLoading.style.display = "none";
          })
          .catch(() => {
            this.isSubmit = false;
            appLoading.style.display = "none";
          });
      }
    },
    showToast(variant, icon, title, message) {
      toast({
        component: ToastificationContent,
        props: {
          title: title,
          icon,
          text: message,
          variant,
        },
      });
    },
    removeImage(type) {
      if (type == "profile") {
        this.$refs.signature.value = null;
        this.currentProfiePhoto = "";
        this.previewProfiePhoto = "";
      }
      if (type == "signature") {
        this.$refs.profilePhoto.value = null;
        this.currentSignature = "";
        this.previewSignature = "";
      }
    },

    uploadImage(type) {
      if (type == "signature") {
        this.currentSignature = this.$refs.signature.files.item(0);
        this.previewSignature = URL.createObjectURL(this.currentSignature);
      }
      if (type == "profile") {
        this.currentProfiePhoto = this.$refs.profilePhoto.files.item(0);
        this.previewProfiePhoto = URL.createObjectURL(this.currentProfiePhoto);
      }
    },
    passwordOtpChange(e, type) {
      if (type == "password_otp_on_mail") {
        this.UserModel.password_otp_on_mail = e;
        if (e == false) {
          this.UserModel.password_otp_on_message = true;
        }
      }
      if (type == "password_otp_on_message") {
        this.UserModel.password_otp_on_message = e;
        if (e == false) {
          this.UserModel.password_otp_on_mail = true;
        }
      }
    },
    checkBoxValueChange(e, type) {
      if (type == "status") {
        this.UserModel.status = e;
      }
      if (type == "ip_based_login_web") {
        this.UserModel.ip_based_login_web = e;
      }
      if (type == "ip_based_login_mobile") {
        this.UserModel.ip_based_login_mobile = e;
      }
      if (type == "otp_based_login_web") {
        this.UserModel.otp_based_login_web = e;
        if (this.UserModel.otp_based_login_web == true) {
          this.UserModel.otp_on_mail = true;
        }
      }

      if (type == "otp_based_login_mobile") {
        this.UserModel.otp_based_login_mobile = e;
        if (this.UserModel.otp_based_login_mobile == true) {
          this.UserModel.otp_on_mail = true;
        }
      }

      if (type == "auto_logout_web") {
        this.UserModel.auto_logout_web = e;
      }
      if (type == "auto_logout_mobile") {
        this.UserModel.auto_logout_mobile = e;
      }

      if (type == "otp_on_mail") {
        this.UserModel.otp_on_mail = e;
      }
      if (type == "otp_on_message") {
        this.UserModel.otp_on_message = e;
      }
      if (type == "otp_on_mail" || type == "otp_on_message") {
        if (this.UserModel.otp_on_mail == true || this.UserModel.otp_on_message == true) {
          if (
            this.UserModel.otp_based_login_mobile == true ||
            this.UserModel.otp_based_login_web == true
          ) {
          } else {
            this.UserModel.otp_based_login_web = true;
            this.UserModel.otp_based_login_mobile = true;
          }
        } else {
          if (
            this.UserModel.otp_on_mail == false &&
            this.UserModel.otp_on_message == false
          ) {
            this.UserModel.otp_based_login_web = false;
            this.UserModel.otp_based_login_mobile = false;
          }
        }
      }
    },
    designationSubmit() {
      store
        .dispatch("users/userOptionList")
        .then((response) => {
          const data = response.data.result;
          this.designationOptions = data.designation;
          let currentDesignation = {
            label: this.UserModel.designationData.name,
            value: this.UserModel.designationData.id,
          };
          let include = false;
          this.designationOptions.forEach((element) => {
            if (include == false && element.value == this.UserModel.designationData.id) {
              include = true;
            }
          });
          if (include == false) {
            this.designationOptions.push(currentDesignation);
          }
        })
        .catch(() => {});
    },
    designationValue(value) {
      this.UserModel.designation = value;
    },
    openModal(value) {
      this.showModal = value;
    },
    isPermission(value) {
      if (this.permissionsSelected.includes(value)) {
        return true;
      } else {
        return false;
      }
    },
    permissionChange(permission, event, perOption) {
      if (!this.permissionsSelected.includes(permission.value)) {
        this.permissionsSelected.push(permission.value);
      }

      if (permission.text != "View") {
        if (!this.permissionsSelected.includes(permission.module + "_view")) {
          this.permissionsSelected.push(permission.module + "_view");
        }
      }

      if (permission.text == "View") {
        if (!event) {
          var modulePermission = this.permissionOptions.filter(function (elem) {
            if (elem.module == perOption.module) {
              return elem;
            }
          });

          const per = modulePermission[0].permissions;
          if (per && per.length > 0) {
            for (var i = 0; i < per.length; i++) {
              if (this.permissionsSelected.includes(per[i].value)) {
                var index = this.permissionsSelected.indexOf(per[i].value);
                this.permissionsSelected.splice(index, 1);
              }
            }
          }

          const mPer = modulePermission[0].more_permissions;
          if (mPer && mPer.length > 0) {
            for (var m = 0; m < mPer.length; m++) {
              if (this.permissionsSelected.includes(mPer[m].value)) {
                var index = this.permissionsSelected.indexOf(mPer[m].value);
                this.permissionsSelected.splice(index, 1);
              }
            }
          }
        }
      }

      if (!event) {
        if (this.permissionsSelected.includes(permission.value)) {
          var index = this.permissionsSelected.indexOf(permission.value);
          this.permissionsSelected.splice(index, 1);
        }
      }
    },
    changeView(type) {
      if (type == "role") {
        this.customizeRole = !this.customizeRole;
        this.addAdditionDetails = false;
      }
      if (type == "details") {
        this.customizeRole = false;
        this.addAdditionDetails = !this.addAdditionDetails;
      }
    },
    format_date_time(value, type) {
      if (value) {
        if (type == "date") {
          return moment(String(value), "YYYY/MM/DD").format("DD/MM/YYYY");
        }
        if (type == "time") {
          return moment(String(value)).format("HH:mm");
          // let time = String(value);
          // const now = new Date();
          // const [hours, minutes, seconds] = time.split(":");
          // now.setHours(hours);
          // now.setMinutes(minutes);
          // now.setSeconds(seconds);
          // return now.toLocaleTimeString();
        }
      }
    },
    time_convert(type, time) {
      console.log('time')
      console.log(time)
      if (type == 1) {
        var customTime = new Date("2023-07-14T" + time);
        var timeZone = Intl.DateTimeFormat().resolvedOptions().timeZone;
        const Time = moment.tz(customTime, timeZone).utc().format("HH:mm:ss");
        return Time;
      }
      if (type == 2) {
        var utc = new Date("2023-07-13T" + time + "Z");
        var timeZone = Intl.DateTimeFormat().resolvedOptions().timeZone;
        return moment.utc(utc).tz(timeZone).format("HH:mm:ss");
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.per-page-selector {
  width: 90px;
}
</style>

<style lang="scss"></style>
